//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#ifndef __bbcreaVtkReadMHDPlane_h_INCLUDED__
#define __bbcreaVtkReadMHDPlane_h_INCLUDED__






#include "bbcreaVtk_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include "vtkImageData.h"
#include "vtkMetaImageReader.h"

namespace bbcreaVtk
{

class bbcreaVtk_EXPORT ReadMHDPlane
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ReadMHDPlane,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
  BBTK_DECLARE_INPUT(FileName,std::string);
  BBTK_DECLARE_INPUT(Slice,int);
  BBTK_DECLARE_INPUT(Width,int);
  BBTK_DECLARE_INPUT(DirectionPlane,std::string);
  BBTK_DECLARE_INPUT(Type,int);
  BBTK_DECLARE_OUTPUT(Out,vtkImageData*); 
  BBTK_PROCESS(Process);
	
  vtkImageData* CreateDefaultImage();
  void ReadNormalMHD();
  void Read64lseek();
  void copy_XZ_plane(int fd,vtkImageData *newImage,int slice,int iWidth,int dimX,int dimY,int dimZ,int dataSize);
  void copy_YZ_plane(int fd,vtkImageData *newImage,int slice,int iWidth,int dimX,int dimY,int dimZ,int dataSize);


  void Process();
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ReadMHDPlane,bbtk::AtomicBlackBox);
 BBTK_NAME("ReadMHDPlane");
 BBTK_AUTHOR("InfoDev");
 BBTK_DESCRIPTION("No Description.");
 BBTK_CATEGORY("empty");
 BBTK_INPUT(ReadMHDPlane,FileName,"Image file name",std::string,"");
 BBTK_INPUT(ReadMHDPlane,Slice,"Slice number",int,"");
 BBTK_INPUT(ReadMHDPlane,Width,"(1 default) Number of slices to be read",int,"");
 BBTK_INPUT(ReadMHDPlane,DirectionPlane,"Direction plane: XY (default), YZ , XZ",std::string,"");
 BBTK_INPUT(ReadMHDPlane,Type,"(1 default) 0 = Normal mhd,  1 = lseek64",int,"");
 BBTK_OUTPUT(ReadMHDPlane,Out,"Image 2D",vtkImageData*,"");
BBTK_END_DESCRIBE_BLACK_BOX(ReadMHDPlane);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
}
// EO namespace bbcreaVtk

#endif // __bbcreaVtkReadMHDPlane_h_INCLUDED__

